unit sCurrencyEdit;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StrUtils, sStyleUtil, ToolEdit, CurrEdit, ComCtrls, 
  ToolWin, ExtCtrls, RXCtrls, sConst;

Type

  TsCurrencyEdit = class(TCurrencyEdit)
  private
    { Private declarations }
    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
  protected
    { Protected declarations }
    FsStyle : TsStyle;
    procedure WndProc (var Message: TMessage); override;
  public
    constructor Create(AOwner:TComponent); override;
    procedure Invalidate; override;
    { Public declarations }
  published
    property AutoSelect;
    property HideSelection;
    property HelpContext;
    property OEMConvert;
    property PasswordChar;
    property ReadOnly;
    property Enabled;
    property Font;
    property Hint;
    property MaxLength;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Text;
    property Visible;
    property CharCase;
    property sStyle:TsStyle read FsStyle write FsStyle;

    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property ImeMode;
    property ImeName;
    property ParentBiDiMode;
    property TabStop;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    { Published declarations }
  end;
implementation

constructor TsCurrencyEdit.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle := TsStyle.Create(Self);
  sStyle.COC := COC_TsCurrencyEdit;
  OnKeyDown := sStyle.onKeyDown;
  DisplayFormat := '### ##0.00;-### ##0.00;0';
  Width := 80;
end;

procedure TsCurrencyEdit.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  if sStyle.Flat then begin
    InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
  end;
end;

procedure TsCurrencyEdit.WMNCPaint(var Message: TMessage);
begin
  Color := sStyle.GetActiveColor;
  inherited;
  sStyle.RedrawBorder;
end;

procedure TsCurrencyEdit.Invalidate;
begin
  if not sStyle.FDrawingStop then begin
    Color := sStyle.GetActiveColor;
    if sStyle.Flat then begin
      BorderStyle := bsNone;
      if Assigned(Parent) then sStyle.RedrawBorder;
    end
    else begin
      BorderStyle := bsSingle;
    end;
    inherited;
  end;
end;

procedure TsCurrencyEdit.WndProc(var Message: TMessage);
begin
   sStyle.WndProc(Message);
   inherited;
end;

end.
