unit sEdit;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StrUtils, sStyleUtil, ToolEdit, CurrEdit, ComCtrls,
  ToolWin, ExtCtrls, RXCtrls, sConst;

Type
  TsEdit = class(TCustomEdit)
  private
    { Private declarations }

    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;

  protected
    FsStyle : TsStyle;

    procedure WndProc (var Message: TMessage); override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    procedure Invalidate; override;
    property BorderStyle;
    property Color;
  published

    property AutoSelect;
    property HideSelection;
    property HelpContext;
    property OEMConvert;
    property PasswordChar;
    property ReadOnly;
    property Enabled;
    property Font;
    property Hint;
    property MaxLength;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Text;
    property Visible;
    property CharCase;

    property sStyle: TsStyle read FsStyle write FsStyle;

    property Anchors;
//    property AutoSize;
    property BiDiMode;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property ImeMode;
    property ImeName;
    property ParentBiDiMode;
    property TabStop;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    property OnEnter;
    property OnExit;

    { Published declarations }
  end;

implementation

constructor TsEdit.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle := TsStyle.Create(Self);
  sStyle.COC := COC_TsEdit;

  ParentFont := True;
  AutoSize := False;
  Ctl3D := False;
  ControlStyle := ControlStyle - [csFramed];
  Height := 21;

  OnKeyDown := sStyle.onKeyDown;
end;

procedure TsEdit.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
end;

procedure TsEdit.Invalidate;
begin
  if not sStyle.FDrawingStop then begin
    Color := sStyle.GetActiveColor;
    if sStyle.Flat then begin
      BorderStyle := bsNone;
      if Assigned(Parent) then sStyle.redrawBorder;
    end
    else begin
      BorderStyle := bsSingle;
    end;
    inherited;
  end;
end;

procedure TsEdit.WndProc(var Message: TMessage);
begin
  sStyle.WndProc(Message);
  if Message.Result <> 1 then inherited;
end;

procedure TsEdit.WMNCPaint(var Message: TMessage);
begin
  inherited;
  Color := sStyle.GetActiveColor;
  sStyle.RedrawBorder;
end;

end.
